/* -*- C++ -*- Time-stamp: <11 Mar 01 11:08:31 Michael Bischoff> */

/*****************************************************************************/
/*									     */
/*									     */
/*	QMatchIt version 1.0 -- file mainwindow.h			     */
/*									     */
/*	Include file for the main application window of QMatchIt	     */
/*	written by Michael Bischoff (Michael.Bischoff@gmx.net)		     */
/*	November-2000							     */
/*	see COPYRIGHT.qmatchit for Copyright details			     */
/*									     */
/*									     */
/*****************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qmainwindow.h>
#include <qstring.h>

class game;
class QTimer;
class QCanvasView;
class QPopupMenu;
class QKeyEvent;

class Mainwindow : public QMainWindow {
    Q_OBJECT
    QPopupMenu *file;
    QPopupMenu *options;

    game *g;
    QTimer *timer;
    QCanvasView *view;
    QString lv_filename;

    bool advanceLevel;
    bool edit_mode;
    int level;
    int dbf_id;
    int edt_id;
    int erase_id;
    void keyPressEvent(QKeyEvent *qe);

public:
    Mainwindow(QWidget *parent = 0, const char *name = 0, WFlags f = 0);
    ~Mainwindow();
    void setLevelFile(const char *, int lv = 0);

private slots:
    void setSpeed(int);
    void animate();
    void aboutQt();
    void aboutQMatchIt();
    void aboutKeys();
    void aboutEditor();

    // slots which call 1:1 the same functions in game
    // (just to avoid inheriting game from QObject)
    void save();
    void load();
    void clear();
    void sameLevel();
    void nextLevel();


    void toggleDoubleBuffer();
    void toggleEditMode();

};

#endif
